//------------------------------------------------------------------
//------------------------------------------------------------------
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  Silver
#property indicator_color2  LimeGreen
#property indicator_color3  LimeGreen
#property indicator_color4  PaleVioletRed
#property indicator_color5  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  3
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  3
#property indicator_minimum 0

//
//
//
//
//

extern int    RsiPeriod = 2;
extern int    RsiPrice  = PRICE_CLOSE;
extern int    AccPeriod = 3;
extern double Level     = 45;

//
//
//
//
//

double rsic[];
double rsicDa[];
double rsicDb[];
double rsicUa[];
double rsicUb[];
double rsi[];
double bellow[];
double Level2;

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);   
      SetIndexBuffer(0,rsic);
      SetIndexBuffer(1,rsicDa);
      SetIndexBuffer(2,rsicDb);
      SetIndexBuffer(3,rsicUa);
      SetIndexBuffer(4,rsicUb);
      SetIndexBuffer(5,rsi);
      SetIndexBuffer(6,bellow);
         Level2 = AccPeriod*100-Level;
            SetLevelValue(0,Level);
            SetLevelValue(1,Level2);
   IndicatorShortName("Accumulated RSI ("+DoubleToStr(RsiPeriod,2)+")");
   return(0);
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   if (bellow[limit] ==-1) CleanPoint(limit,rsicDa,rsicDb);
   if (bellow[limit] == 1) CleanPoint(limit,rsicUa,rsicUb);
   for(int i=limit; i>=0; i--)
   {         
      rsi[i]    = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
      rsic[i]   = 0;
      rsicDa[i] = EMPTY_VALUE;
      rsicDb[i] = EMPTY_VALUE;
      rsicUa[i] = EMPTY_VALUE;
      rsicUb[i] = EMPTY_VALUE;
      bellow[i] = bellow[i+1];
         for (int k=0; k<AccPeriod; k++) rsic[i] += rsi[i+k];
         if (rsic[i]<Level)                    bellow[i] = -1;
         if (rsic[i]>Level2)                   bellow[i] =  1;
         if (rsic[i]>Level && rsic[i]<Level2)  bellow[i] =  0;
         if (bellow[i] == 1) PlotPoint(i,rsicUa,rsicUb,rsic);
         if (bellow[i] ==-1) PlotPoint(i,rsicDa,rsicDb,rsic);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}